=== modified file 'ChangeLog'
--- ChangeLog	2006-08-09 14:25:03 +0000
+++ ChangeLog	2006-08-09 14:39:28 +0000
@@ -1,5 +1,8 @@
 2006-08-09  Szilveszter Farkas <Szilveszter.Farkas@gmail.com>
 
+    * olive.glade: added Rename dialog
+    * olive/frontend/gtk/rename.py: implemented OliveRename
+    * olive/frontend/gtk/handler.py: added Rename signal handler
     * olive/frontend/gtk/__init__.py: fixed the double-click Bookmarks bug
     * olive/frontend/gtk/move.py: implemented OliveMove
     * olive/frontend/gtk/handler.py: added Move signal handler

=== modified file 'olive.glade'
--- olive.glade	2006-08-09 14:08:12 +0000
+++ olive.glade	2006-08-09 14:39:28 +0000
@@ -52,7 +52,7 @@
 		      <signal name="activate" handler="on_menuitem_add_files_activate" last_modification_time="Fri, 21 Jul 2006 11:38:39 GMT"/>
 
 		      <child internal-child="image">
-			<widget class="GtkImage" id="image144">
+			<widget class="GtkImage" id="image152">
 			  <property name="visible">True</property>
 			  <property name="stock">gtk-add</property>
 			  <property name="icon_size">1</property>
@@ -73,7 +73,7 @@
 		      <signal name="activate" handler="on_menuitem_remove_file_activate" last_modification_time="Fri, 21 Jul 2006 13:54:07 GMT"/>
 
 		      <child internal-child="image">
-			<widget class="GtkImage" id="image145">
+			<widget class="GtkImage" id="image153">
 			  <property name="visible">True</property>
 			  <property name="stock">gtk-remove</property>
 			  <property name="icon_size">1</property>
@@ -194,7 +194,7 @@
 		      <signal name="activate" handler="on_menuitem_branch_pull_activate" last_modification_time="Mon, 17 Jul 2006 08:52:48 GMT"/>
 
 		      <child internal-child="image">
-			<widget class="GtkImage" id="image146">
+			<widget class="GtkImage" id="image154">
 			  <property name="visible">True</property>
 			  <property name="pixbuf">pull16.png</property>
 			  <property name="xalign">0.5</property>
@@ -214,7 +214,7 @@
 		      <signal name="activate" handler="on_menuitem_branch_push_activate" last_modification_time="Mon, 17 Jul 2006 08:52:48 GMT"/>
 
 		      <child internal-child="image">
-			<widget class="GtkImage" id="image147">
+			<widget class="GtkImage" id="image155">
 			  <property name="visible">True</property>
 			  <property name="pixbuf">push16.png</property>
 			  <property name="xalign">0.5</property>
@@ -240,7 +240,7 @@
 		      <signal name="activate" handler="on_menuitem_branch_commit_activate" last_modification_time="Mon, 17 Jul 2006 08:53:37 GMT"/>
 
 		      <child internal-child="image">
-			<widget class="GtkImage" id="image148">
+			<widget class="GtkImage" id="image156">
 			  <property name="visible">True</property>
 			  <property name="pixbuf">commit16.png</property>
 			  <property name="xalign">0.5</property>
@@ -288,7 +288,7 @@
 		      <signal name="activate" handler="on_menuitem_stats_diff_activate" last_modification_time="Thu, 03 Aug 2006 11:35:30 GMT"/>
 
 		      <child internal-child="image">
-			<widget class="GtkImage" id="image149">
+			<widget class="GtkImage" id="image157">
 			  <property name="visible">True</property>
 			  <property name="pixbuf">diff16.png</property>
 			  <property name="xalign">0.5</property>
@@ -308,7 +308,7 @@
 		      <signal name="activate" handler="on_menuitem_stats_log_activate" last_modification_time="Thu, 03 Aug 2006 11:35:43 GMT"/>
 
 		      <child internal-child="image">
-			<widget class="GtkImage" id="image150">
+			<widget class="GtkImage" id="image158">
 			  <property name="visible">True</property>
 			  <property name="pixbuf">log16.png</property>
 			  <property name="xalign">0.5</property>
@@ -2584,7 +2584,6 @@
 
 <widget class="GtkWindow" id="window_move">
   <property name="width_request">250</property>
-  <property name="visible">True</property>
   <property name="title" translatable="yes">Olive - Move</property>
   <property name="type">GTK_WINDOW_TOPLEVEL</property>
   <property name="window_position">GTK_WIN_POS_NONE</property>
@@ -2766,4 +2765,189 @@
   </child>
 </widget>
 
+<widget class="GtkWindow" id="window_rename">
+  <property name="title" translatable="yes">Olive - Rename</property>
+  <property name="type">GTK_WINDOW_TOPLEVEL</property>
+  <property name="window_position">GTK_WIN_POS_NONE</property>
+  <property name="modal">False</property>
+  <property name="resizable">True</property>
+  <property name="destroy_with_parent">False</property>
+  <property name="icon">oliveicon2.png</property>
+  <property name="decorated">True</property>
+  <property name="skip_taskbar_hint">False</property>
+  <property name="skip_pager_hint">False</property>
+  <property name="type_hint">GDK_WINDOW_TYPE_HINT_DIALOG</property>
+  <property name="gravity">GDK_GRAVITY_NORTH_WEST</property>
+  <property name="focus_on_map">True</property>
+  <property name="urgency_hint">False</property>
+
+  <child>
+    <widget class="GtkVBox" id="vbox_rename">
+      <property name="border_width">5</property>
+      <property name="visible">True</property>
+      <property name="homogeneous">False</property>
+      <property name="spacing">3</property>
+
+      <child>
+	<widget class="GtkHBox" id="hbox_rename">
+	  <property name="visible">True</property>
+	  <property name="homogeneous">False</property>
+	  <property name="spacing">5</property>
+
+	  <child>
+	    <widget class="GtkLabel" id="label_rename">
+	      <property name="visible">True</property>
+	      <property name="label" translatable="yes">Rename to</property>
+	      <property name="use_underline">False</property>
+	      <property name="use_markup">False</property>
+	      <property name="justify">GTK_JUSTIFY_LEFT</property>
+	      <property name="wrap">False</property>
+	      <property name="selectable">False</property>
+	      <property name="xalign">0.5</property>
+	      <property name="yalign">0.5</property>
+	      <property name="xpad">0</property>
+	      <property name="ypad">0</property>
+	      <property name="ellipsize">PANGO_ELLIPSIZE_NONE</property>
+	      <property name="width_chars">-1</property>
+	      <property name="single_line_mode">False</property>
+	      <property name="angle">0</property>
+	    </widget>
+	    <packing>
+	      <property name="padding">0</property>
+	      <property name="expand">False</property>
+	      <property name="fill">False</property>
+	    </packing>
+	  </child>
+
+	  <child>
+	    <widget class="GtkEntry" id="entry_rename">
+	      <property name="visible">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="has_focus">True</property>
+	      <property name="editable">True</property>
+	      <property name="visibility">True</property>
+	      <property name="max_length">0</property>
+	      <property name="text" translatable="yes"></property>
+	      <property name="has_frame">True</property>
+	      <property name="invisible_char">●</property>
+	      <property name="activates_default">False</property>
+	    </widget>
+	    <packing>
+	      <property name="padding">0</property>
+	      <property name="expand">True</property>
+	      <property name="fill">True</property>
+	    </packing>
+	  </child>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">True</property>
+	  <property name="fill">True</property>
+	</packing>
+      </child>
+
+      <child>
+	<widget class="GtkHButtonBox" id="hbuttonbox_rename">
+	  <property name="visible">True</property>
+	  <property name="layout_style">GTK_BUTTONBOX_SPREAD</property>
+	  <property name="spacing">3</property>
+
+	  <child>
+	    <widget class="GtkButton" id="button_rename_rename">
+	      <property name="visible">True</property>
+	      <property name="can_default">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="relief">GTK_RELIEF_NORMAL</property>
+	      <property name="focus_on_click">True</property>
+	      <signal name="clicked" handler="on_button_rename_rename_clicked" last_modification_time="Wed, 09 Aug 2006 14:28:53 GMT"/>
+
+	      <child>
+		<widget class="GtkAlignment" id="alignment10">
+		  <property name="visible">True</property>
+		  <property name="xalign">0.5</property>
+		  <property name="yalign">0.5</property>
+		  <property name="xscale">0</property>
+		  <property name="yscale">0</property>
+		  <property name="top_padding">0</property>
+		  <property name="bottom_padding">0</property>
+		  <property name="left_padding">0</property>
+		  <property name="right_padding">0</property>
+
+		  <child>
+		    <widget class="GtkHBox" id="hbox13">
+		      <property name="visible">True</property>
+		      <property name="homogeneous">False</property>
+		      <property name="spacing">2</property>
+
+		      <child>
+			<widget class="GtkImage" id="image159">
+			  <property name="visible">True</property>
+			  <property name="stock">gtk-apply</property>
+			  <property name="icon_size">4</property>
+			  <property name="xalign">0.5</property>
+			  <property name="yalign">0.5</property>
+			  <property name="xpad">0</property>
+			  <property name="ypad">0</property>
+			</widget>
+			<packing>
+			  <property name="padding">0</property>
+			  <property name="expand">False</property>
+			  <property name="fill">False</property>
+			</packing>
+		      </child>
+
+		      <child>
+			<widget class="GtkLabel" id="label20">
+			  <property name="visible">True</property>
+			  <property name="label" translatable="yes">_Rename</property>
+			  <property name="use_underline">True</property>
+			  <property name="use_markup">False</property>
+			  <property name="justify">GTK_JUSTIFY_LEFT</property>
+			  <property name="wrap">False</property>
+			  <property name="selectable">False</property>
+			  <property name="xalign">0.5</property>
+			  <property name="yalign">0.5</property>
+			  <property name="xpad">0</property>
+			  <property name="ypad">0</property>
+			  <property name="ellipsize">PANGO_ELLIPSIZE_NONE</property>
+			  <property name="width_chars">-1</property>
+			  <property name="single_line_mode">False</property>
+			  <property name="angle">0</property>
+			</widget>
+			<packing>
+			  <property name="padding">0</property>
+			  <property name="expand">False</property>
+			  <property name="fill">False</property>
+			</packing>
+		      </child>
+		    </widget>
+		  </child>
+		</widget>
+	      </child>
+	    </widget>
+	  </child>
+
+	  <child>
+	    <widget class="GtkButton" id="button_rename_cancel">
+	      <property name="visible">True</property>
+	      <property name="can_default">True</property>
+	      <property name="can_focus">True</property>
+	      <property name="label">gtk-cancel</property>
+	      <property name="use_stock">True</property>
+	      <property name="relief">GTK_RELIEF_NORMAL</property>
+	      <property name="focus_on_click">True</property>
+	      <signal name="clicked" handler="on_button_rename_cancel_clicked" last_modification_time="Wed, 09 Aug 2006 14:29:00 GMT"/>
+	    </widget>
+	  </child>
+	</widget>
+	<packing>
+	  <property name="padding">0</property>
+	  <property name="expand">False</property>
+	  <property name="fill">False</property>
+	</packing>
+      </child>
+    </widget>
+  </child>
+</widget>
+
 </glade-interface>

=== modified file 'olive/frontend/gtk/__init__.py'
--- olive/frontend/gtk/__init__.py	2006-08-09 14:25:03 +0000
+++ olive/frontend/gtk/__init__.py	2006-08-09 14:39:28 +0000
@@ -65,7 +65,7 @@
                 "on_menuitem_remove_file_activate": handler.on_menuitem_remove_file_activate,
                 "on_menuitem_file_make_directory_activate": handler.on_menuitem_file_make_directory_activate,
                 "on_menuitem_file_move_activate": handler.on_menuitem_file_move_activate,
-                "on_menuitem_file_rename_activate": handler.not_implemented,
+                "on_menuitem_file_rename_activate": handler.on_menuitem_file_rename_activate,
                 "on_menuitem_branch_initialize_activate": handler.on_menuitem_branch_initialize_activate,
                 "on_menuitem_branch_get_activate": handler.on_menuitem_branch_get_activate,
                 "on_menuitem_branch_checkout_activate": handler.on_menuitem_branch_checkout_activate,

=== modified file 'olive/frontend/gtk/handler.py'
--- olive/frontend/gtk/handler.py	2006-08-09 14:08:12 +0000
+++ olive/frontend/gtk/handler.py	2006-08-09 14:39:28 +0000
@@ -124,6 +124,12 @@
         move = OliveMove(self.gladefile, self.comm)
         move.display()
     
+    def on_menuitem_file_rename_activate(self, widget):
+        """ File/Rename... menu handler. """
+        from rename import OliveRename
+        rename = OliveRename(self.gladefile, self.comm)
+        rename.display()
+
     def on_menuitem_remove_file_activate(self, widget):
         """ Remove (unversion) selected file. """
         from remove import OliveRemove

=== added file 'olive/frontend/gtk/rename.py'
--- olive/frontend/gtk/rename.py	1970-01-01 00:00:00 +0000
+++ olive/frontend/gtk/rename.py	2006-08-09 14:39:28 +0000
@@ -0,0 +1,92 @@
+# Copyright (C) 2006 by Szilveszter Farkas (Phanatic) <szilveszter.farkas@gmail.com>
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+
+import os
+import sys
+
+try:
+    import pygtk
+    pygtk.require("2.0")
+except:
+    pass
+try:
+    import gtk
+    import gtk.glade
+except:
+    sys.exit(1)
+
+import olive.backend.errors as errors
+import olive.backend.fileops as fileops
+
+from dialog import OliveDialog
+
+class OliveRename:
+    """ Display the Rename dialog and perform the needed actions. """
+    def __init__(self, gladefile, comm):
+        """ Initialize the Rename dialog. """
+        self.gladefile = gladefile
+        self.glade = gtk.glade.XML(self.gladefile, 'window_rename')
+        
+        self.comm = comm
+        
+        self.dialog = OliveDialog(self.gladefile)
+        
+        self.window = self.glade.get_widget('window_rename')
+        
+        # Dictionary for signal_autoconnect
+        dic = { "on_button_rename_rename_clicked": self.rename,
+                "on_button_rename_cancel_clicked": self.close }
+        
+        # Connect the signals to the handlers
+        self.glade.signal_autoconnect(dic)
+        
+    def display(self):
+        """ Display the Rename dialog. """
+        self.window.show_all()
+
+    def rename(self, widget):
+        # Get entry
+        entry = self.glade.get_widget('entry_rename')
+        
+        old_filename = self.comm.get_selected_right()
+        new_filename = entry.get_text()
+            
+        if old_filename is None:
+            self.dialog.error_dialog('No file was selected.')
+            return
+        
+        if new_filename == "":
+            self.dialog.error_dialog('New filename not specified.')
+            return
+        
+        source = self.comm.get_path() + '/' + old_filename
+        destination = self.comm.get_path() + '/' + new_filename
+        
+        # Rename the file
+        try:
+            fileops.rename(source, destination)
+        except errors.NotBranchError:
+            self.dialog.error_dialog('Selected file is not in a branch.')
+            return
+        except errors.NotSameBranchError:
+            self.dialog.error_dialog('The destination is not in the same branch.')
+            return
+
+        self.close()
+        self.comm.refresh_right()
+    
+    def close(self, widget=None):
+        self.window.destroy()

